// GenGraph.cpp : implementation file
//

#include "stdafx.h"
#include "GenGraph.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGenGraph

CGenGraph::CGenGraph()
	: m_Width(0), m_Height(0), m_pFitness(NULL)
{
}

CGenGraph::~CGenGraph()
{
	if (m_pFitness != NULL)
		delete[] m_pFitness;
}


BEGIN_MESSAGE_MAP(CGenGraph, CStatic)
	//{{AFX_MSG_MAP(CGenGraph)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGenGraph message handlers

void CGenGraph::Init(int max)
{
	GetClientRect(m_rect);
	Invalidate();
	m_nMaxHeight = max;
	m_Height = m_rect.Height();
	m_Width = m_rect.Width();
	m_nScores = (int)(m_Width / 2);
	if (m_pFitness != NULL)
		delete[] m_pFitness;
	m_pFitness = new int[m_nScores];
	for (int i=0; i<m_nScores; i++)
		m_pFitness[i] = 0;
	m_nFitness = 0;
}

void CGenGraph::AddFitness(int generation, int fitness)
{
	// Show this value, but since it wraps over and over
	// clear out the 10th value out in front of it
	// (that way the 10 values in front are always clear):
	int WrapGen = generation % m_nScores;
	int WrapGen10 = (generation + 10) % m_nScores;
	m_pFitness[WrapGen] = fitness;
	m_pFitness[WrapGen10] = 0;
	CRect r = m_rect;
	r.left = WrapGen * 2;
	r.right = (WrapGen * 2) + 1;
	InvalidateRect(r);
	r.left = WrapGen10 * 2;
	r.right = (WrapGen10 * 2) + 1;
	InvalidateRect(r);
}

void CGenGraph::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	dc.Rectangle(m_rect);

	// if it hasn't been initted, no business painting:
	if (m_pFitness == NULL)
		return;

	float scaling = ((float)m_Height / m_nMaxHeight);

	CPen redpen(PS_SOLID, 1, RGB(255,0,0));
	CPen blackpen(PS_SOLID, 1, RGB(0,0,0));
	CPen *pOldPen = dc.SelectObject(&blackpen);
	dc.MoveTo(0, m_Height-1);
	dc.LineTo(0, (int)((m_nMaxHeight - m_pFitness[0]) * scaling));
	for (int i=1; i<m_nScores; i++)
	{
		if (m_pFitness[i] > m_pFitness[i-1])
			dc.SelectObject(&redpen);
		else
			dc.SelectObject(&blackpen);
		dc.MoveTo(i * 2, m_Height-1);
		dc.LineTo(i * 2, (int)((m_nMaxHeight - m_pFitness[i]) * scaling));
	}
	dc.SelectObject(pOldPen);
}
