#if !defined(AFX_LAYOUT_H__ECB2B7F8_DD73_11D4_8DC3_A03076BFB153__INCLUDED_)
#define AFX_LAYOUT_H__ECB2B7F8_DD73_11D4_8DC3_A03076BFB153__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Layout.h : header file
//

#include <afxtempl.h>
#include "Random.h"

// These are the possible positions of the labels.
// These will be encoded into the genes of the CLayout.
// This is not an enum because random ones have to be
//  picked and it's easy to pick a random int but not
//  a random enum member.
#define	UL	0	// Upper Left
#define	UR	1	// Upper Right
#define LL	2	// Lower Left
#define LR	3	// Lower Right

// The size of the Label Rectangle in points.
#define LBL_WIDTH	60
#define LBL_HEIGHT	12

/////////////////////////////////////////////////////////////////////////////
// CLayout window

class CLayout : public CStatic
{
// Construction
public:
	CLayout();
	CLayout(const CLayout &copy);

// Attributes
public:
	CArray<CPoint, CPoint&>	m_Points;	// Filled by the Doc's Gen
	CArray<int, int&>		m_Genes;	// Filled by the Doc's Gen
	CArray<CRect, CRect&>	m_Rects;	// Filled by DetermineFitness
	CArray<BOOL, BOOL&>		m_Overlaps;	// Filled by DetermineFitness

	Random<int>				m_randomPos;
	Random<int>				m_randomParent;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLayout)
	//}}AFX_VIRTUAL

// Implementation
public:
	int DetermineFitness();
	int GetPtCnt();
	void Init(const CArray<CPoint, CPoint&>& ptarray);
	virtual ~CLayout();

	CLayout& operator=(const CLayout &right);
//	CLayout operator*(const CLayout &dad);
	void MakeChild(const CLayout &mom, const CLayout &dad);

	// Generated message map functions
protected:
	//{{AFX_MSG(CLayout)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LAYOUT_H__ECB2B7F8_DD73_11D4_8DC3_A03076BFB153__INCLUDED_)
