// MapView.cpp : implementation file
//

#include "stdafx.h"
#include "Carto.h"
#include "CartoDoc.h"
#include "MapView.h"
#include "Layout.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapView

IMPLEMENT_DYNCREATE(CMapView, CScrollView)

CMapView::CMapView()
{
}

CMapView::~CMapView()
{
}


BEGIN_MESSAGE_MAP(CMapView, CScrollView)
	//{{AFX_MSG_MAP(CMapView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapView drawing

void CMapView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 306;
	sizeTotal.cy = 396;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

void CMapView::OnDraw(CDC* pDC)
{
	// There are a lot of PS points that fit on a page.
	// Too many to show on the screen.  We'll scale
	// by simply assigning 1 pixel = 2 points.
	CCartoDoc* pDoc = GetDocument();

	// Draw Border:
	pDC->MoveTo(18, 18);
	pDC->LineTo(18, 378);
	pDC->LineTo(288, 378);
	pDC->LineTo(288, 18);
	pDC->LineTo(18,18);

	// Draw all the point features:
	CBrush redBrush(RGB(255,0,0));
	CRect r;
	CPoint pt;
	int x, y;
	for (int i=0; i<pDoc->m_PtCnt; i++)
	{
		// Get this point:
		pt = pDoc->m_Gen.bestEver.m_Points[i];
		x = (pt.x / 2);		// Convert 1 pixel = 2 PS points
		y = 396 - (pt.y / 2);	// Our coordinates are in the 4th quad.

		if (pDoc->m_Gen.bestEver.m_Overlaps[i] == TRUE)
			pDC->SelectObject(&redBrush);
		else
			pDC->SelectStockObject(HOLLOW_BRUSH);

		// Calculate this scaled rectangle (1 pix = 2 PS pts):
		switch (pDoc->m_Gen.bestEver.m_Genes[i])
		{
		  case UL:
			r = CRect(x-(LBL_WIDTH/2), y-(LBL_HEIGHT/2),
						x, y);
			break;
		  case UR:
			r = CRect(x, y-(LBL_HEIGHT/2),
						x+(LBL_WIDTH/2), y);
			break;
		  case LL:
			r = CRect(x-(LBL_WIDTH/2), y,
						x, y+(LBL_HEIGHT/2));
			break;
		  case LR:
			r = CRect(x, y,
						x+(LBL_WIDTH/2), y+(LBL_HEIGHT/2));
			break;
		}
		pDC->Rectangle(r);
		pDC->Ellipse(x-2, y-2, x+2, y+2);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMapView diagnostics

#ifdef _DEBUG
void CMapView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMapView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMapView message handlers

void CMapView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	Invalidate();
}

CCartoDoc* CMapView::GetDocument()
{
	return (CCartoDoc*)m_pDocument;
}
